<template>
  <v-col>
    <v-col class="mb-2">
      <v-row align="end">
        <v-btn v-if="$vuetify.breakpoint.smAndUp && !clienteActual" color="accent" @click="abrirForm">
          <v-icon left>
            fal fa-user-plus
          </v-icon>
          Nueva historia clínica
        </v-btn>
        <label v-if="detalleCliente">
          Historias Clínicas
        </label>
        <v-spacer v-if="$vuetify.breakpoint.smAndUp" />
        <v-text-field
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          :style="$vuetify.breakpoint.smAndDown ? 'display: block' : 'max-width: 40vh'"
        />
      </v-row>
    </v-col>
    <v-expansion-panels
      v-if="!detalleCliente"
      hover
      flat
      multiple
      class="mt-8"
    >
      <v-expansion-panel>
        <v-expansion-panel-header color="rgba(141,88,193,0.34)">
          <v-row justify="start" align="center">
            <v-icon class="mr-2">
              fal fa-filter
            </v-icon><label>Filtros</label>
          </v-row>
        </v-expansion-panel-header>
        <v-expansion-panel-content :class="!$vuetify.theme.dark ? 'grey lighten-3' : 'grey darken-3'">
          <v-row class="mb-2" row wrap>
            <v-col xs3 sm3 class="mb-2 pr-4">
              <v-select
                v-model="filters.nivel1"
                label="Clientes"
                placeholder="Filtrar"
                item-text="nombre"
                item-value="nombre"
                color="accent"
                small
                clearable
                multiple
                chips
                :items="clientes"
              />
            </v-col>
            <v-col
              xs3
              sm3
              class="mb-2 pr-4"
            >
              <v-select
                v-model="filters.nivel2"
                label="Mascotas"
                placeholder="Filtrar"
                item-text="nombre"
                item-value="nombre"
                color="accent"
                small
                multiple
                chips
                clearable
                :items="mascotas"
              />
            </v-col>
            <v-col
              xs3
              sm3
              class="mb-2 pr-4"
            >
              <v-select
                v-model="filters.tipo"
                label="Veterinarios"
                placeholder="Filtrar"
                item-text="name"
                item-value="name"
                color="accent"
                small
                multiple
                chips
                clearable
                :items="veterinarios"
              />
            </v-col>
          </v-row>
        </v-expansion-panel-content>
      </v-expansion-panel>
    </v-expansion-panels>

    <v-data-table
      ref="tabla"
      :items-per-page="10"
      :headers="headers"
      :items="clienteActual ? filtradoListaFilter : filtradoLista"
      :search="search"
      class="elevation-1"
    >
      <template #[`item.action`]="{ item }">
        <v-btn
          color="accent"
          small
          outlined

          @click="abrirDetalle(item)"
        >
          Detalle
        </v-btn>
      </template>
      <template #[`item.icons`]="{ item }">
        <v-icon
          small
          class="mr-2 fal fa-edit"
          @click="modificarHistoriaClinica(item)"
        />
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarHistoriaClinica(item.idhistorias)"
        />
      </template>
    </v-data-table>
    <v-dialog v-model="dialogObs" width="700" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card v-if="dialogObs">
        <v-card-title>Observaciones</v-card-title>
        <v-card-text>
          <v-textarea
            v-model="Obs"
            outlined
            disabled
            color="accent"
            label="Observaciones"
          />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="cerrarDetalle">
            Cerrar
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import { HistoriaClinica } from '~/core/models/historiaClinica'
import { HistoriasClinicasStore } from '~/store/HistoriasClinicasStore'
import AppToast from '~/core/utils/AppToast'
import { Cliente } from '~/core/models/cliente'
import { ClientesStore } from '~/store/ClientesStore'
import { MascotasStore } from '~/store/MascotasStore'
import { VeterinariosStore } from '~/store/VeterinariosStore'
import { Veterinario } from '~/core/models/veterinario'
import { Mascota } from '~/core/models/mascota'

@Component
export default class listaHistoriasClinicas extends Vue {
  @Ref() tabla;

  @Prop({ default: null }) clienteActual!:Cliente;
  @Prop({ default: false }) detalleCliente!:boolean;

  search = '';
  dialogObs:Boolean = false;
  Obs:String = '';

  filters = {
    nivel1: [],
    tipo: [],
    nivel2: []
  };

  headers = [
    { text: 'Cliente', align: 'left', value: 'cliente' },
    { text: 'Mascota', align: 'left', value: 'mascota' },
    { text: 'Veterinario', align: 'left', value: 'veterinario' },
    { value: 'action', align: 'right', sortable: false },
    { value: 'icons', align: 'right', sortable: false, width: 80 }
  ];

  get historiasClinicasFilter ():HistoriaClinica[] {
    return this.historiasClinicas.filter(p => p.clientes_idclientes === this.clienteActual.idclientes)
  }

  get clientes ():Cliente[] {
    return ClientesStore.listaClientes
  }

  get veterinarios ():Veterinario[] {
    return VeterinariosStore.listaVeterinarios
  }

  get mascotas ():Mascota[] {
    return MascotasStore.mascotas
  }

  get filtradoLista () {
    return this.historiasClinicas.filter((d) => {
      return Object.keys(this.filters).every((f) => {
        return this.filters[f].length < 1 || this.filters[f].includes(d[f])
      })
    })
  }

  get filtradoListaFilter () {
    return this.historiasClinicasFilter.filter((d) => {
      return Object.keys(this.filters).every((f) => {
        return this.filters[f].length < 1 || this.filters[f].includes(d[f])
      })
    })
  }

  get historiasClinicas ():HistoriaClinica[] {
    return HistoriasClinicasStore.historiasClinicas.map((p, index) => {
      const x = ClientesStore.listaClientesIndexed[p.clientes_idclientes]
      const y = MascotasStore.mascotasIndexes[p.mascotas_idmascotas]
      const z = VeterinariosStore.listaVeterinariosIndexed[p.veterinarios_idveterinarios]
      return {
        ...p,
        cliente: x ? x.nombre : 'Desconocido',
        mascota: y ? y.nombre : 'Desconocido',
        veterinario: z ? z.name : 'Desconocido',
        index
      }
    })
  }

  abrirDetalle (historiaClinica:HistoriaClinica) {
    this.Obs = historiaClinica.observaciones
    this.dialogObs = true
  }

  cerrarDetalle () {
    this.Obs = null
    this.dialogObs = false
  }

  modificarHistoriaClinica (val) {
    this.$emit('onEdit', val)
  }

  abrirForm () {
    this.$emit('onAbrir')
  }

  eliminarHistoriaClinica (id:number) {
    this.$confirm('¿Está seguro?').then(async (res) => {
      if (res) {
        await HistoriasClinicasStore.eliminarHistoriaClinica(id)
        AppToast.info('Historia Clínica eliminada')
      }
    }).catch()
  }
}
</script>

<style lang="scss">

</style>
